from command_parser import logger

from command_parser.flag import Flag
from command_parser.value import Value

def parse(line: str, flags: list[Flag], values: list[Value]):
    """
    parse a command line parser
    """
    logger.info("parsing a line")
    elements = line.split(" ")
    index = 0
    while index < len(elements):
        element = elements[index]
        logger.debug(
            _("parsing element {element}".format(element=element))
        )
        try:
            if element[0] != "-":
                for flag in flags:
                    if flag.one() in element:
                        flag.apply()
                        if len(element) == 1:
                            index += 1
                        else:
                            elements[index] = element.replace(
                                flag.one(), ""
                            )
                for value in values:
                    if value.one() == element:
                        value.apply(elements[index + 1])
                        index += 2
            elif element[1] != "-":
                for flag in flags:
                    if flag.short() == element:
                        flag.apply()
                        index += 1
                for value in values:
                    if value.one() == element:
                        value.apply(elements[index + 1])
                        index += 2
            else:
                for flag in flags:
                    if flag.long() == element:
                        flag.apply()
                        index += 1
                for value in values:
                    if value.long() == element[: len(value.long())]:
                        value.apply(element[len(value.long())])
                        index += 1
        except IndexError:
            logger.warning(_("empty value"))
